
# line 2 "appointment_File_Yaccer.ym"
/*
    kfc - Kurt's Free Calendar
    Copyright 1995 Kurt Werle

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#import "appointmentFile.h"
#import "anAppointment.h"
#import <misckit/MiscFile.h>
#warning I wish lex and Yacc didn't give all these (useless) warning messages.
/* NOTE!!! If you edit this file and try to recompile you will need to 'make clean' first!!! */

id		self; /* This is embarrassing!!! */
BOOL		isEditable;
List		*theAppointmentList;
anAppointment	*myAppointment;
extern FILE	*yyin;


# line 35 "appointment_File_Yaccer.ym"
typedef union  {
	int aweekday;
	int amonth;
	int anumber;
	char *amessage;
	} YYSTYPE;
# define REMINDER 257
# define REPEAT 258
# define BACK 259
# define WARN 260
# define AT 261
# define BONUS 262
# define PRIORITY 263
# define UNTILSTART 264
# define WEEKDAY 265
# define MONTH 266
# define NUMBER 267
# define MESSAGE 268
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 181 "appointment_File_Yaccer.ym"


@implementation appointmentFile(File_Loader)

- loadFile:sender
{
    if (appointmentList == nil)
    {
	appointmentList = [[List alloc] init];
    }
    else			/* bogus */
    {
	return self;
    }

    theAppointmentList = appointmentList;
    myAppointment = [[anAppointment alloc] init];
    isEditable = ([[self myFile] access:MISCFILE_WRITE] == MISCFILE_SUCCESS);

    [myAppointment setIsEditable:isEditable];

    yyin = fopen ([myFile fullPath], "rt");
    if (!yyin)
    {
	return self;
    }

    yyparse ();

    [myAppointment free];
    return self;
}

@end
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 41
# define YYLAST 70
short yyact[]={

  39,  31,  51,  50,  49,  38,  37,  36,  34,  33,
  29,  20,  19,  16,  14,  11,   7,   9,  13,  28,
  26,  27,  45,  18,  44,   3,  46,  41,  22,   2,
  -1,   4,  43,  42,  40,  32,  25,  24,  23,  21,
  15,  10,   6,  30,  17,  12,   8,   5,   1,   0,
   0,  35,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  47,   0,   0,   0,   0,  48 };
short yypact[]={

-232,-232,-1000,-249,-1000,-247,-251,-1000,-245,-252,
-254,-1000,-238,-255,-256,-239,-257,-267,-258,-1000,
-259,-1000,-239,-1000,-1000,-1000,-260,-261,-262,-1000,
-268,-1000,-236, -32,-1000,-239,-1000,-1000,-1000,-1000,
-1000,-236,-1000,-1000,-263,-264,-265,-1000,-1000,-1000,
-1000,-1000 };
short yypgo[]={

   0,  48,  29,  47,  46,  45,  44,  43,  42,  41,
  40,  39,  28,  38,  37,  36,  35,  34,  27,  33,
  32,  30 };
short yyr1[]={

   0,   1,   1,   1,   2,   3,   8,   8,   9,   9,
  10,  10,  10,  11,  11,  11,  11,  12,  12,  12,
  13,  14,  15,   4,   4,   5,   5,   6,   6,  16,
  17,  17,  17,  18,  18,  19,  20,   7,   7,  21,
  21 };
short yyr2[]={

   0,   2,   1,   0,   6,   4,   1,   0,   1,   0,
   2,   1,   0,   3,   2,   1,   0,   1,   1,   1,
   2,   2,   2,   4,   0,   2,   0,   3,   0,   3,
   2,   1,   0,   1,   1,   2,   2,   2,   1,   2,
   1 };
short yychk[]={

-1000,  -1,  -2, 257,  -2,  -3,  -8, 265,  -4, 264,
  -9, 266,  -5, 263, 266, -10, 267,  -6, 261, 267,
 267, -11, -12, -13, -14, -15, 259, 260, 258, 267,
  -7, 268, -16, 267, 267, -12, 267, 267, 267, 268,
 -17, -18, -19, -20, 260, 258,  58, -12, -18, 267,
 267, 267 };
short yydef[]={

   3,  -2,   2,   7,   1,  24,   9,   6,  26,   0,
  12,   8,  28,   0,   0,  16,  11,   0,   0,  25,
   0,   5,  15,  17,  18,  19,   0,   0,   0,  10,
   4,  38,  32,   0,  23,  14,  20,  21,  22,  37,
  27,  31,  33,  34,   0,   0,   0,  13,  30,  35,
  36,  29 };
# line 1 "/usr/lib/yaccpar"
#ifndef lint
static char yaccpar_sccsid[] = "@(#)yaccpar	4.1	(Berkeley)	2/11/83";
#endif not lint

# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps>= &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 1:
# line 51 "appointment_File_Yaccer.ym"
{
		    [theAppointmentList addObject:myAppointment];
#ifdef DEBUG
		    printf ("Just loaded %s\n",[myAppointment appointmentTextFirstLine]);
#endif
		    myAppointment = [[anAppointment alloc] init];
		    [myAppointment setIsEditable:isEditable];
		} break;
case 2:
# line 60 "appointment_File_Yaccer.ym"
{
		    [theAppointmentList addObject:myAppointment];
#ifdef DEBUG
		    printf ("Just loaded %s\n",[myAppointment appointmentTextFirstLine]);
#endif
		    myAppointment = [[anAppointment alloc] init];
		    [myAppointment setIsEditable:isEditable];
		} break;
case 4:
# line 71 "appointment_File_Yaccer.ym"
{;} break;
case 6:
# line 77 "appointment_File_Yaccer.ym"
{[myAppointment setWeekDay:yypvt[-0].aweekday];} break;
case 8:
# line 81 "appointment_File_Yaccer.ym"
{[myAppointment setMonth:yypvt[-0].amonth];} break;
case 10:
# line 85 "appointment_File_Yaccer.ym"
{[[myAppointment setDay:yypvt[-1].anumber-1] setYear:yypvt[-0].anumber];} break;
case 11:
# line 87 "appointment_File_Yaccer.ym"
{
		    if (yypvt[-0].anumber > 31)
		    {
			[myAppointment setYear:yypvt[-0].anumber];
		    }
		    else
		    {
			[myAppointment setDay:yypvt[-0].anumber-1];
		    }
		} break;
case 20:
# line 111 "appointment_File_Yaccer.ym"
{[myAppointment setBack:yypvt[-0].anumber];} break;
case 21:
# line 113 "appointment_File_Yaccer.ym"
{[myAppointment setDelta:yypvt[-0].anumber];} break;
case 22:
# line 115 "appointment_File_Yaccer.ym"
{[myAppointment setRepeat:yypvt[-0].anumber];} break;
case 23:
# line 119 "appointment_File_Yaccer.ym"
{
		[myAppointment setUntilYear:yypvt[-0].anumber Month:yypvt[-2].amonth Day:yypvt[-1].anumber-1];
		} break;
case 25:
# line 125 "appointment_File_Yaccer.ym"
{[myAppointment setPriority:yypvt[-0].anumber];} break;
case 29:
# line 133 "appointment_File_Yaccer.ym"
{[[myAppointment setHour:yypvt[-2].anumber] setMinute:yypvt[-0].anumber];} break;
case 35:
# line 144 "appointment_File_Yaccer.ym"
{[myAppointment setTdelta:yypvt[-0].anumber];} break;
case 36:
# line 147 "appointment_File_Yaccer.ym"
{[myAppointment setTrepeat:yypvt[-0].anumber];} break;
case 37:
# line 151 "appointment_File_Yaccer.ym"
{
		    char               *tempptr = yypvt[-0].amessage;

		    while (tempptr = strchr (tempptr, '\\'))
		    {
			*tempptr = '\n';
			tempptr++;
		    }
		    [[myAppointment appointmentText] cat:yypvt[-0].amessage];
		    [[myAppointment appointmentText] replaceRegex:"MSG +" with:"" caseSensitive:NO];
		    [[myAppointment appointmentText] replaceEveryOccurrenceOfRegex:" *\n *" with:"\n" caseSensitive:NO];
		} break;
case 38:
# line 164 "appointment_File_Yaccer.ym"
{
		    char               *tempptr = yypvt[-0].amessage;

		    while (tempptr = strchr (tempptr, '\\'))
		    {
			*tempptr = '\n';
			tempptr++;
		    }
		    [[myAppointment appointmentText] cat:yypvt[-0].amessage];
		    [[myAppointment appointmentText] replaceRegex:"MSG +" with:"" caseSensitive:NO];
		    [[myAppointment appointmentText] replaceEveryOccurrenceOfRegex:" *\n *" with:"\n" caseSensitive:NO];
		} break;
case 40:
# line 179 "appointment_File_Yaccer.ym"
{printf("can't deal with that yet\n");} break;
# line 148 "/usr/lib/yaccpar"

		}
		goto yystack;  /* stack new state and value */

	}
